#!/bin/sh

# Tested on FC3, FC4, and RHEL4
# You will need to modify this script based on your laptop
# This works on a T42 with bluetooth, and Intel BG2200 Wirless
# Chris Vanhoof <vanhoof@redhat.com>


#########
##SLEEP##
#########

## this is network manager specific
/usr/bin/dbus-send --system 
    --dest=org.freedesktop.NetworkManager
    --type=method_call 
    /org/freedesktop/NetworkManager 
    org.freedesktop.NetworkManager.sleep

/sbin/hwclock --systohc

## stoping dund
/usr/bin/killall dund

## stopping bluetooth
/usr/sbin/hciconfig hci0 down
/etc/init.d/bluetooth stop

## pulling modules
/sbin/rmmod hci_usb
/sbin/rmmod ehci_hcd
/sbin/rmmod uhci_hcd
/sbin/rmmod usb-uhci
/sbin/rmmod rfcomm
/sbin/rmmod l2cap
/sbin/rmmod bluetooth
/bin/sleep 2 
echo -n mem > /sys/power/state



#########
##AWAKE##
#########

/sbin/hwclock --hctosys

## start bluetooth 
/etc/init.d/bluetooth start

## reload modules
/sbin/modprobe hci_usb
/sbin/modprobe ehci_hcd
/sbin/modprobe uhci_hcd
/sbin/modprobe usb-uhci
/sbin/modprobe rfcomm
/sbin/modprobe l2cap
/sbin/modprobe bluetooth
/bin/sleep 2

## start dund again
/usr/bin/dund --listen --persist call treo

## network manager specific
/usr/bin/dbus-send --system 
    --dest=org.freedesktop.NetworkManager
    --type=method_call 
    /org/freedesktop/NetworkManager 
    org.freedesktop.NetworkManager.wake
